unit TypingTutor;

interface

uses                    
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, KeyboardPanel, TyperPanel, Menus, Global, Buttons, ToolWin,
  ComCtrls, shellapi, EndDialog;

type
  TMainForm = class(TForm)
    KeyboardPanel: TKeyboardPanel;
    TyperPanel: TTyperPanel;
    Panel: TPanel;
    ChangeBookSpeedButton: TSpeedButton;
    SaveSettingsSpeedButton: TSpeedButton;
    ExitSpeedButton: TSpeedButton;
    HelpSpeedButton: TSpeedButton;
    OpenDialog    : TOpenDialog;
    procedure KeyboardPanelKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure ChangeBookSpeedButtonClick(Sender: TObject);
    procedure ExitSpeedButtonClick(Sender: TObject);
    procedure SaveSettingsSpeedButtonClick(Sender: TObject);
    procedure HelpSpeedButtonClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

  private
     OriginalWidth, OriginalHeight : integer;
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}


procedure TMainForm.KeyboardPanelKeyPress(Sender: TObject; var Key: Char);
begin
  TyperPanel.KeyPressed(Sender,Key);
  KeyboardPanel.SelectChar(TyperPanel.GetCurrentChar);
end;



procedure TMainForm.FormCreate(Sender: TObject);
begin
  TyperPanel.Open;
  ScaleBy(round(sqrt(Screen.Width*Screen.Height)),round(sqrt(640*480)));
  OriginalWidth := Width;
  OriginalHeight := Height;
  KeyboardPanel.SelectChar(TyperPanel.GetCurrentChar);
end;

procedure TMainForm.FormResize(Sender: TObject);
begin
  KeyboardPanel.ScaleBy(round(sqrt(Width*Height)),round(sqrt(OriginalWidth*OriginalHeight)));
  TyperPanel.ScaleBy(round(sqrt(Width*Height)),round(sqrt(OriginalWidth*OriginalHeight)));
  TyperPanel.Top := KeyboardPanel.Height;
  OriginalWidth := Width;
  OriginalHeight := Height;
end;

procedure TMainForm.ChangeBookSpeedButtonClick(Sender: TObject);
begin
  if OpenDialog.Execute then begin
    TyperPanel.FileName := OpenDialog.FileName;
    TyperPanel.Open;
    KeyboardPanel.SelectChar(TyperPanel.GetCurrentChar);
  end;
end;

procedure TMainForm.ExitSpeedButtonClick(Sender: TObject);
begin
  OkBottomDlg.Show;
end;

procedure TMainForm.SaveSettingsSpeedButtonClick(Sender: TObject);
begin
  KeyboardPanel.SaveIni;
end;

procedure TMainForm.HelpSpeedButtonClick(Sender: TObject);
var HelpFile : String;
begin
     HelpFile := GetCurrentDir+'\help.html';
     Shellexecute(0,nil,Pchar(HelpFile),nil,nil,SW_NORMAL);
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     Halt;
end;

end.
